## otb 5.6.0+dfsg

=== CMakeLists.txt ===
if(WIN32)
  cmake_minimum_required(VERSION 2.8.8 FATAL_ERROR)
else()
  cmake_minimum_required(VERSION 2.8.6 FATAL_ERROR)
endif()

foreach(p
    CMP0025 # CMake 3.0
    CMP0042 # CMake 3.0
    CMP0058
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()

# CMP0046 : from CMake 3.0, old behaviour is more convenient
if(POLICY CMP0046)
  cmake_policy(SET CMP0046 OLD)
endif()

# TODO Check if OTB cmake is compatible with CMP0054 NEW policy
# CMP0054 : New policy introduce in CMake 3.1, keep old behaviour for now
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 OLD)
endif()

project(OTB)

include(CMakeDependentOption)
#
# use ExternalProject
include(ExternalProject)

#mantis: 1193
if(APPLE)
  set(CMAKE_SYSTEM_FRAMEWORK_PATH "" CACHE PATH "" FORCE)
endif()

if( CMAKE_HOST_WIN32 )

  string( LENGTH "${CMAKE_CURRENT_SOURCE_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "OTB source code directory path length is too long (${n} > 50)."
      "Please move the OTB source code directory to a directory with a shorter path."
      )
  endif()

  string( LENGTH "${CMAKE_CURRENT_BINARY_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "OTB build directory path length is too long (${n} > 50)."
      "Please set the OTB build directory to a directory with a shorter path."
      )
  endif()

endif()

set(OTB_CMAKE_DIR ${OTB_SOURCE_DIR}/CMake)
set(CMAKE_MODULE_PATH ${OTB_CMAKE_DIR} ${CMAKE_MODULE_PATH})
include (SourceStatus)
include(PreventInSourceBuilds)
include(PreventInBuildInstalls)
include(OTBModuleMacros)
include(OTBModuleRemote)
include(OTBModuleTest)

repository_status(${PROJECT_SOURCE_DIR} OTB_GIT_STATUS_MESSAGE)

#-----------------------------------------------------------------------------
# Configure the default OTB_DATA_ROOT for the location of OTB Data.
find_path(OTB_DATA_ROOT
  NAMES README-OTB-Data
  HINTS $ENV{OTB_DATA_ROOT} ${OTB_SOURCE_DIR}/../OTB-Data
)
mark_as_advanced(OTB_DATA_ROOT)

if(OTB_DATA_ROOT)
  repository_status(${OTB_DATA_ROOT} OTB_DATA_GIT_STATUS_MESSAGE)
endif()

set(main_project_name ${_OTBModuleMacros_DEFAULT_LABEL})

#-----------------------------------------------------------------------------
# OTB version number.
set(OTB_VERSION_MAJOR "5")
set(OTB_VERSION_MINOR "6")
set(OTB_VERSION_PATCH "0")
set(OTB_VERSION_STRING "${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR}.${OTB_VERSION_PATCH}")

string(TIMESTAMP OTB_BUILD_TIMESTAMP)

if(NOT OTB_INSTALL_RUNTIME_DIR)
  set(OTB_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT OTB_INSTALL_LIBRARY_DIR)
  set(OTB_INSTALL_LIBRARY_DIR lib)
endif()
if(NOT OTB_INSTALL_ARCHIVE_DIR)
  set(OTB_INSTALL_ARCHIVE_DIR lib)
endif()
if(NOT OTB_INSTALL_INCLUDE_DIR)
  set(OTB_INSTALL_INCLUDE_DIR include/OTB-${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR})
endif()
if(NOT OTB_INSTALL_APP_DIR)
  set(OTB_INSTALL_APP_DIR "lib/otb/applications")
endif()
if(NOT OTB_INSTALL_PYTHON_DIR)
  set(OTB_INSTALL_PYTHON_DIR "lib/otb/python")
endif()
if(NOT OTB_INSTALL_JAVA_DIR)
  set(OTB_INSTALL_JAVA_DIR "lib/otb/java")
endif()
if(NOT OTB_INSTALL_DATA_DIR)
  set(OTB_INSTALL_DATA_DIR share/OTB-${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR})
endif()
if(NOT OTB_INSTALL_DOC_DIR)
  set(OTB_INSTALL_DOC_DIR share/doc/OTB-${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR})
endif()
if(NOT OTB_INSTALL_PACKAGE_DIR)
  set(OTB_INSTALL_PACKAGE_DIR "${OTB_INSTALL_LIBRARY_DIR}/cmake/OTB-${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR}")
endif()

# Override CMake's built-in add_* commands: assign LABELS to tests and targets
# automatically. Depends on the CMake variable otb-module being set to the
# "current" module when add_* is called.
macro(verify_otb_module_is_set)
  if("" STREQUAL "${otb-module}")
    message(FATAL_ERROR "CMake variable otb-module is not set")
  endif()
endmacro()

#-----------------------------------------------------------------------------
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()


#-----------------------------------------------------------------------------
# Enable running cppcheck for each module on its source and test directories.
option(OTB_CPPCHECK_TEST "Run cppcheck for static code analysis" OFF)
mark_as_advanced(OTB_CPPCHECK_TEST)

#-----------------------------------------------------------------------------
# Forbid downloading resources from the network during a build. This helps
# when building on systems without network connectivity to determine which
# resources much be obtained manually and made available to the build.
option(OTB_FORBID_DOWNLOADS "Do not download source code or data from the network" OFF)
mark_as_advanced(OTB_FORBID_DOWNLOADS)
macro(otb_download_attempt_check _name)
  if(OTB_FORBID_DOWNLOADS)
    message(SEND_ERROR "Attempted to download ${_name} when OTB_FORBID_DOWNLOADS is ON")
  endif()
endmacro()

# TODO : handle shared libs on windows
option(BUILD_SHARED_LIBS "Build OTB with shared libraries." ON)
set(OTB_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

#-----------------------------------------------------------------------------
# Option to activate deprecated classes
option(OTB_USE_DEPRECATED "Turn on the use and test of deprecated classes" OFF)
mark_as_advanced(OTB_USE_DEPRECATED)

#-----------------------------------------------------------------------------
# SHOW_ALL_MSG_DEBUG option
option(OTB_SHOW_ALL_MSG_DEBUG "Show all debug messages (very verbose)" OFF)
mark_as_advanced(OTB_SHOW_ALL_MSG_DEBUG)

include(OTBSetStandardCompilerFlags)
#---------------------------------------------------------------
# run try compiles and tests for OTB

# TODO check if we need this
#include(otbTestFriendTemplatedFunction)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OTB_REQUIRED_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OTB_REQUIRED_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OTB_REQUIRED_LINK_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${OTB_REQUIRED_LINK_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${OTB_REQUIRED_LINK_FLAGS}")

# detect some C++11 keywords
include(OTBCheckCpp11Keywords)

# TODO BUILD_TESTING is created by default by CTest.cmake, and is ON by default.
option(BUILD_TESTING "Build the testing tree." OFF)

include(CTest)

include( CppcheckTargets )

# Setup build locations.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${OTB_BINARY_DIR}/bin)
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${OTB_BINARY_DIR}/lib)
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${OTB_BINARY_DIR}/lib)
endif()
set(OTB_MODULES_DIR "${OTB_BINARY_DIR}/${OTB_INSTALL_PACKAGE_DIR}/Modules")

#-----------------------------------------------------------------------------
# OTB uses KWStyle for checking the coding style
#include(${OTB_SOURCE_DIR}/Utilities/KWStyle/KWStyle.cmake)

#-----------------------------------------------------------------------------
# By default, OTB does not build the Examples that are illustrated in the Software Guide
option(BUILD_EXAMPLES "Build the Examples directory." OFF)

#----------------------------------------------------------------------------
set(OTB_TEST_OUTPUT_DIR "${OTB_BINARY_DIR}/Testing/Temporary")

option(OTB_DATA_USE_LARGEINPUT "Use Large inputs images test." OFF)
mark_as_advanced(OTB_DATA_USE_LARGEINPUT)
if(OTB_DATA_USE_LARGEINPUT)
  find_path(OTB_DATA_LARGEINPUT_ROOT
    NAMES OTBData.readme
    HINTS $ENV{OTB_DATA_LARGEINPUT_ROOT}
  )
  mark_as_advanced(OTB_DATA_LARGEINPUT_ROOT)
endif()

#Generate cmake variables with a set of largeinput data used in tests
include(OTBManageLargeInputPaths)

set(BASELINE       ${OTB_DATA_ROOT}/Baseline/OTB/Images)
set(BASELINE_FILES ${OTB_DATA_ROOT}/Baseline/OTB/Files)
set(INPUTDATA      ${OTB_DATA_ROOT}/Input)
set(TEMP           ${OTB_BINARY_DIR}/Testing/Temporary)
set(EXAMPLEDATA    ${OTB_DATA_ROOT}/Examples)
set(OTBAPP_BASELINE       ${OTB_DATA_ROOT}/Baseline/OTB-Applications/Images)
set(OTBAPP_BASELINE_FILES ${OTB_DATA_ROOT}/Baseline/OTB-Applications/Files)

set(NOTOL      0.0)
set(EPSILON_1  0.1)
set(EPSILON_2  0.01)
set(EPSILON_3  0.001)
set(EPSILON_4  0.0001)
set(EPSILON_5  0.00001)
set(EPSILON_6  0.000001)
set(EPSILON_7  0.0000001)
set(EPSILON_8  0.00000001)
set(EPSILON_9  0.000000001)
set(EPSILON_10 0.0000000001)
set(EPSILON_11 0.00000000001)
set(EPSILON_12 0.000000000001)
set(EPSILON_13 0.0000000000001)
set(EPSILON_14 0.00000000000001)
set(EPSILON_15 0.000000000000001)

# Location of OTB Example Data.
set(OTB_EXAMPLE_DATA_ROOT "${OTB_SOURCE_DIR}/Examples/Data")

#----------------------------------------------------------------------
# Make sure remote modules are downloaded before sorting out the module
# dependencies.
add_subdirectory(Modules/Remote)

# Enable modules according to user inputs and the module dependency DAG.
include(OTBModuleEnablement)

#----------------------------------------------------------------------
# Generate OTBConfig.cmake for the build tree.
set(OTB_CONFIG_CODE "
set(OTB_MODULES_DIR \"${OTB_MODULES_DIR}\")")
set(OTB_CONFIG_CMAKE_DIR "${OTB_SOURCE_DIR}/CMake")
set(OTB_USE_FILE "${OTB_CONFIG_CMAKE_DIR}/UseOTB.cmake")
set(OTB_CONFIG_TARGETS_CONDITION " AND NOT OTB_BINARY_DIR")
set(OTB_CONFIG_TARGETS_FILE "${OTB_BINARY_DIR}/OTBTargets.cmake")
set(OTB_CONFIG_MODULE_API_FILE "${OTB_SOURCE_DIR}/CMake/OTBModuleAPI.cmake")
set(OTB_CONFIG_APPLI_MACROS_FILE "${OTB_SOURCE_DIR}/CMake/OTBApplicationMacros.cmake")
configure_file(CMake/OTBConfig.cmake.in OTBConfig.cmake @ONLY)

# Generate OTBConfig.cmake for the install tree.
set(OTB_CONFIG_CODE "
# Compute the installation prefix from this OTBConfig.cmake file location.
get_filename_component(OTB_INSTALL_PREFIX \"\${CMAKE_CURRENT_LIST_FILE}\" PATH)")
# Construct the proper number of get_filename_component(... PATH)
# calls to compute the installation prefix.
string(REGEX REPLACE "/" ";" _count "${OTB_INSTALL_PACKAGE_DIR}")
foreach(p ${_count})
  set(OTB_CONFIG_CODE "${OTB_CONFIG_CODE}
get_filename_component(OTB_INSTALL_PREFIX \"\${OTB_INSTALL_PREFIX}\" PATH)")
endforeach()
set(OTB_CONFIG_CODE "${OTB_CONFIG_CODE}
set(OTB_MODULES_DIR \"\${OTB_INSTALL_PREFIX}/${OTB_INSTALL_PACKAGE_DIR}/Modules\")")
set(OTB_USE_FILE "\${OTB_INSTALL_PREFIX}/${OTB_INSTALL_PACKAGE_DIR}/UseOTB.cmake")
set(OTB_CONFIG_CMAKE_DIR "\${OTB_INSTALL_PREFIX}/${OTB_INSTALL_PACKAGE_DIR}")
set(OTB_CONFIG_TARGETS_CONDITION "")
set(OTB_CONFIG_TARGETS_FILE "\${OTB_INSTALL_PREFIX}/${OTB_INSTALL_PACKAGE_DIR}/OTBTargets.cmake")
set(OTB_CONFIG_MODULE_API_FILE "\${OTB_INSTALL_PREFIX}/${OTB_INSTALL_PACKAGE_DIR}/OTBModuleAPI.cmake")
set(OTB_CONFIG_APPLI_MACROS_FILE "\${OTB_INSTALL_PREFIX}/${OTB_INSTALL_PACKAGE_DIR}/OTBApplicationMacros.cmake")

configure_file(CMake/OTBConfig.cmake.in CMakeFiles/OTBConfig.cmake @ONLY)

# TODO : port unscrustify scripts from ITK to OTB ?
# #----------------------------------------------------------------------------
# # Configure maintenance scripts
# configure_file(Utilities/Maintenance/doSingleKWStyleUncrustifyFix.sh.in
#   Utilities/Maintenance/doSingleKWStyleUncrustifyFix.sh @ONLY)

#-----------------------------------------------------------------------------
configure_file(CMake/OTBConfigVersion.cmake.in OTBConfigVersion.cmake @ONLY)

install(FILES ${OTB_BINARY_DIR}/CMakeFiles/OTBConfig.cmake
              ${OTB_BINARY_DIR}/OTBConfigVersion.cmake
              CMake/OTBApplicationMacros.cmake
              CMake/OTBModuleAPI.cmake
              CMake/UseOTB.cmake
  DESTINATION ${OTB_INSTALL_PACKAGE_DIR}
  COMPONENT Development)
get_property(OTBTargets_MODULES GLOBAL PROPERTY OTBTargets_MODULES)

=== Examples/ChangeDetection/CMakeLists.txt ===
project(ChangeDetectionExamples)

add_executable(ChangeDetectionFrameworkExample ChangeDetectionFrameworkExample.cxx)
target_link_libraries(ChangeDetectionFrameworkExample ${OTB_LIBRARIES})

add_executable(CorrelChDet CorrelChDet.cxx)
target_link_libraries(CorrelChDet ${OTB_LIBRARIES})

add_executable(DiffChDet DiffChDet.cxx)
target_link_libraries(DiffChDet ${OTB_LIBRARIES})

add_executable(JHMIChDet JHMIChDet.cxx)
target_link_libraries(JHMIChDet ${OTB_LIBRARIES})

add_executable(KullbackLeiblerDistanceChDet KullbackLeiblerDistanceChDet.cxx)
target_link_libraries(KullbackLeiblerDistanceChDet ${OTB_LIBRARIES})

add_executable(KullbackLeiblerProfileChDet KullbackLeiblerProfileChDet.cxx)
target_link_libraries(KullbackLeiblerProfileChDet ${OTB_LIBRARIES})

add_executable(KullbackLeiblerSupervizedDistanceChDet KullbackLeiblerSupervizedDistanceChDet.cxx)
target_link_libraries(KullbackLeiblerSupervizedDistanceChDet ${OTB_LIBRARIES})

add_executable(LHMIChDet LHMIChDet.cxx)
target_link_libraries(LHMIChDet ${OTB_LIBRARIES})

add_executable(MultivariateAlterationDetector MultivariateAlterationDetector.cxx)
target_link_libraries(MultivariateAlterationDetector ${OTB_LIBRARIES})

add_executable(RatioChDet RatioChDet.cxx)
target_link_libraries(RatioChDet ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/DimensionReduction/CMakeLists.txt ===
project(DimensionReductionExamples)

add_executable(ICAExample ICAExample.cxx)
target_link_libraries(ICAExample ${OTB_LIBRARIES})

add_executable(MaximumAutocorrelationFactor MaximumAutocorrelationFactor.cxx)
target_link_libraries(MaximumAutocorrelationFactor ${OTB_LIBRARIES})

add_executable(MNFExample MNFExample.cxx)
target_link_libraries(MNFExample ${OTB_LIBRARIES})

add_executable(NAPCAExample NAPCAExample.cxx)
target_link_libraries(NAPCAExample ${OTB_LIBRARIES})

add_executable(PCAExample PCAExample.cxx)
target_link_libraries(PCAExample ${OTB_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/FeatureExtraction/CMakeLists.txt ===
project(FeatureExtractionExamples)

add_executable(AssymmetricFusionOfLineDetectorExample AssymmetricFusionOfLineDetectorExample.cxx)
target_link_libraries(AssymmetricFusionOfLineDetectorExample ${OTB_LIBRARIES})

add_executable(CloudDetectionExample CloudDetectionExample.cxx)
target_link_libraries(CloudDetectionExample ${OTB_LIBRARIES})

add_executable(ComplexMomentPathExample ComplexMomentPathExample.cxx)
target_link_libraries(ComplexMomentPathExample ${OTB_LIBRARIES})

add_executable(ComplexMomentsImageFunctionExample ComplexMomentsImageFunctionExample.cxx)
target_link_libraries(ComplexMomentsImageFunctionExample ${OTB_LIBRARIES})

add_executable(CorrelationLineDetectorExample CorrelationLineDetectorExample.cxx)
target_link_libraries(CorrelationLineDetectorExample ${OTB_LIBRARIES})

add_executable(EdgeDensityExample EdgeDensityExample.cxx)
target_link_libraries(EdgeDensityExample ${OTB_LIBRARIES})

#OTBRoadExtraction depends OTBMathParser. But OTB_USE_MUPARSER is OFF
if(OTBMathParser_LOADED)
add_executable(ExtractRoadByStepsExample ExtractRoadByStepsExample.cxx)
target_link_libraries(ExtractRoadByStepsExample ${OTB_LIBRARIES})

add_executable(ExtractRoadExample ExtractRoadExample.cxx)
target_link_libraries(ExtractRoadExample ${OTB_LIBRARIES})

add_executable(ParallelLineDetectionExample ParallelLineDetectionExample.cxx)
target_link_libraries(ParallelLineDetectionExample ${OTB_LIBRARIES})

add_executable(AlignmentsExample AlignmentsExample.cxx)
target_link_libraries(AlignmentsExample ${OTB_LIBRARIES})
endif()

add_executable(ExtractSegmentsByStepsExample ExtractSegmentsByStepsExample.cxx)
target_link_libraries(ExtractSegmentsByStepsExample ${OTB_LIBRARIES})

add_executable(ExtractSegmentsExample ExtractSegmentsExample.cxx)
target_link_libraries(ExtractSegmentsExample ${OTB_LIBRARIES})

add_executable(FlusserMomentsImageFunctionExample FlusserMomentsImageFunctionExample.cxx)
target_link_libraries(FlusserMomentsImageFunctionExample ${OTB_LIBRARIES})

add_executable(HarrisExample HarrisExample.cxx)
target_link_libraries(HarrisExample ${OTB_LIBRARIES})

add_executable(HuMomentsImageFunctionExample HuMomentsImageFunctionExample.cxx)
target_link_libraries(HuMomentsImageFunctionExample ${OTB_LIBRARIES})

if (Module_OTBVectorDataRendering AND OTB_USE_MAPNIK)
  add_executable(LineSegmentDetectorExample LineSegmentDetectorExample.cxx)
  target_link_libraries(LineSegmentDetectorExample ${OTB_LIBRARIES})

  add_executable(RightAngleDetectionExample RightAngleDetectionExample.cxx)
  target_link_libraries(RightAngleDetectionExample ${OTB_LIBRARIES})
endif()

add_executable(LocalHoughExample LocalHoughExample.cxx)
target_link_libraries(LocalHoughExample ${OTB_LIBRARIES})

add_executable(PanTexExample PanTexExample.cxx)
target_link_libraries(PanTexExample ${OTB_LIBRARIES})

add_executable(RatioLineDetectorExample RatioLineDetectorExample.cxx)
target_link_libraries(RatioLineDetectorExample ${OTB_LIBRARIES})

add_executable(SeamCarvingExample SeamCarvingExample.cxx)
target_link_libraries(SeamCarvingExample ${OTB_LIBRARIES})

add_executable(SeamCarvingOtherExample SeamCarvingOtherExample.cxx)
target_link_libraries(SeamCarvingOtherExample ${OTB_LIBRARIES})

add_executable(SFSExample SFSExample.cxx)
target_link_libraries(SFSExample ${OTB_LIBRARIES})

add_executable(SURFExample SURFExample.cxx)
target_link_libraries(SURFExample ${OTB_LIBRARIES})

add_executable(TextureExample TextureExample.cxx)
target_link_libraries(TextureExample ${OTB_LIBRARIES})

add_executable(ThresholdToPointSetExample ThresholdToPointSetExample.cxx)
target_link_libraries(ThresholdToPointSetExample ${OTB_LIBRARIES})

add_executable(TouziEdgeDetectorExample TouziEdgeDetectorExample.cxx)
target_link_libraries(TouziEdgeDetectorExample ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/Filtering/CMakeLists.txt ===
project(FilteringExamples)

add_executable(BinaryThresholdImageFilter BinaryThresholdImageFilter.cxx)
target_link_libraries(BinaryThresholdImageFilter ${OTB_LIBRARIES})

add_executable(CannyEdgeDetectionImageFilter CannyEdgeDetectionImageFilter.cxx)
target_link_libraries(CannyEdgeDetectionImageFilter ${OTB_LIBRARIES})

add_executable(CompositeFilterExample CompositeFilterExample.cxx)
target_link_libraries(CompositeFilterExample ${OTB_LIBRARIES})

add_executable(DanielssonDistanceMapImageFilter DanielssonDistanceMapImageFilter.cxx)
target_link_libraries(DanielssonDistanceMapImageFilter ${OTB_LIBRARIES})

add_executable(DerivativeImageFilter DerivativeImageFilter.cxx)
target_link_libraries(DerivativeImageFilter ${OTB_LIBRARIES})

add_executable(DiscreteGaussianImageFilter DiscreteGaussianImageFilter.cxx)
target_link_libraries(DiscreteGaussianImageFilter ${OTB_LIBRARIES})

add_executable(GeometriesChangeSpatialReference GeometriesChangeSpatialReference.cxx)
target_link_libraries(GeometriesChangeSpatialReference ${OTB_LIBRARIES})

add_executable(GeometriesFilter GeometriesFilter.cxx)
target_link_libraries(GeometriesFilter ${OTB_LIBRARIES})

add_executable(GradientAnisotropicDiffusionImageFilter GradientAnisotropicDiffusionImageFilter.cxx)
target_link_libraries(GradientAnisotropicDiffusionImageFilter ${OTB_LIBRARIES})

add_executable(GradientMagnitudeImageFilter GradientMagnitudeImageFilter.cxx)
target_link_libraries(GradientMagnitudeImageFilter ${OTB_LIBRARIES})

add_executable(GradientMagnitudeRecursiveGaussianImageFilter GradientMagnitudeRecursiveGaussianImageFilter.cxx)
target_link_libraries(GradientMagnitudeRecursiveGaussianImageFilter ${OTB_LIBRARIES})

add_executable(LaplacianRecursiveGaussianImageFilter1 LaplacianRecursiveGaussianImageFilter1.cxx)
target_link_libraries(LaplacianRecursiveGaussianImageFilter1 ${OTB_LIBRARIES})

add_executable(LaplacianRecursiveGaussianImageFilter2 LaplacianRecursiveGaussianImageFilter2.cxx)
target_link_libraries(LaplacianRecursiveGaussianImageFilter2 ${OTB_LIBRARIES})

add_executable(MathematicalMorphologyBinaryFilters MathematicalMorphologyBinaryFilters.cxx)
target_link_libraries(MathematicalMorphologyBinaryFilters ${OTB_LIBRARIES})

add_executable(MathematicalMorphologyGrayscaleFilters MathematicalMorphologyGrayscaleFilters.cxx)
target_link_libraries(MathematicalMorphologyGrayscaleFilters ${OTB_LIBRARIES})

add_executable(MeanImageFilter MeanImageFilter.cxx)
target_link_libraries(MeanImageFilter ${OTB_LIBRARIES})

add_executable(MedianImageFilter MedianImageFilter.cxx)
target_link_libraries(MedianImageFilter ${OTB_LIBRARIES})

add_executable(SecondDerivativeRecursiveGaussianImageFilter SecondDerivativeRecursiveGaussianImageFilter.cxx)
target_link_libraries(SecondDerivativeRecursiveGaussianImageFilter ${OTB_LIBRARIES})

add_executable(ThresholdImageFilter ThresholdImageFilter.cxx)
target_link_libraries(ThresholdImageFilter ${OTB_LIBRARIES})

if (Module_OTBVectorDataRendering)
  add_executable(RasterizationExample RasterizationExample.cxx)
  target_link_libraries(RasterizationExample ${OTB_LIBRARIES})
endif()

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/Markov/CMakeLists.txt ===
project(MarkovExamples)

add_executable(MarkovClassification1Example MarkovClassification1Example.cxx)
target_link_libraries(MarkovClassification1Example ${OTB_LIBRARIES})

add_executable(MarkovClassification2Example MarkovClassification2Example.cxx)
target_link_libraries(MarkovClassification2Example ${OTB_LIBRARIES})

add_executable(MarkovClassification3Example MarkovClassification3Example.cxx)
target_link_libraries(MarkovClassification3Example ${OTB_LIBRARIES})

add_executable(MarkovRegularizationExample MarkovRegularizationExample.cxx)
target_link_libraries(MarkovRegularizationExample ${OTB_LIBRARIES})

add_executable(MarkovRestaurationExample MarkovRestaurationExample.cxx)
target_link_libraries(MarkovRestaurationExample ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/Projections/CMakeLists.txt ===
project(ProjectionsExamples)

add_executable(CoordinateToNameExample CoordinateToNameExample.cxx)
target_link_libraries(CoordinateToNameExample ${OTB_LIBRARIES})

add_executable(EstimateRPCSensorModelExample EstimateRPCSensorModelExample.cxx)
target_link_libraries(EstimateRPCSensorModelExample ${OTB_LIBRARIES})

add_executable(GeometriesProjectionExample GeometriesProjectionExample.cxx)
target_link_libraries(GeometriesProjectionExample ${OTB_LIBRARIES})

add_executable(MapProjectionExample MapProjectionExample.cxx)
target_link_libraries(MapProjectionExample ${OTB_LIBRARIES})

add_executable(OrthoRectificationExample OrthoRectificationExample.cxx)
target_link_libraries(OrthoRectificationExample ${OTB_LIBRARIES})

add_executable(PlaceNameToLonLatExample PlaceNameToLonLatExample.cxx)
target_link_libraries(PlaceNameToLonLatExample ${OTB_LIBRARIES})

add_executable(SensorModelExample SensorModelExample.cxx)
target_link_libraries(SensorModelExample ${OTB_LIBRARIES})

add_executable(VectorDataExtractROIExample VectorDataExtractROIExample.cxx)
target_link_libraries(VectorDataExtractROIExample ${OTB_LIBRARIES})

add_executable(VectorDataProjectionExample VectorDataProjectionExample.cxx)
target_link_libraries(VectorDataProjectionExample ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/Segmentation/CMakeLists.txt ===
project(SegmentationExamples)

add_executable(ConfidenceConnected ConfidenceConnected.cxx)
target_link_libraries(ConfidenceConnected ${OTB_LIBRARIES})

add_executable(ConnectedThresholdImageFilter ConnectedThresholdImageFilter.cxx)
target_link_libraries(ConnectedThresholdImageFilter ${OTB_LIBRARIES})

add_executable(FastMarchingImageFilter FastMarchingImageFilter.cxx)
target_link_libraries(FastMarchingImageFilter ${OTB_LIBRARIES})

add_executable(IsolatedConnectedImageFilter IsolatedConnectedImageFilter.cxx)
target_link_libraries(IsolatedConnectedImageFilter ${OTB_LIBRARIES})

add_executable(LabelizeNeighborhoodConnectedImageFilter LabelizeNeighborhoodConnectedImageFilter.cxx)
target_link_libraries(LabelizeNeighborhoodConnectedImageFilter ${OTB_LIBRARIES})

add_executable(NeighborhoodConnectedImageFilter NeighborhoodConnectedImageFilter.cxx)
target_link_libraries(NeighborhoodConnectedImageFilter ${OTB_LIBRARIES})

add_executable(OtsuMultipleThresholdImageFilter OtsuMultipleThresholdImageFilter.cxx)
target_link_libraries(OtsuMultipleThresholdImageFilter ${OTB_LIBRARIES})

add_executable(OtsuThresholdImageFilter OtsuThresholdImageFilter.cxx)
target_link_libraries(OtsuThresholdImageFilter ${OTB_LIBRARIES})

if(OTBMathParser_LOADED)
  add_executable(StreamingMeanShiftSegmentation StreamingMeanShiftSegmentation.cxx)
  target_link_libraries(StreamingMeanShiftSegmentation ${OTB_LIBRARIES})
endif()

add_executable(VectorConfidenceConnected VectorConfidenceConnected.cxx)
target_link_libraries(VectorConfidenceConnected ${OTB_LIBRARIES})

add_executable(WatershedSegmentation WatershedSegmentation.cxx)
target_link_libraries(WatershedSegmentation ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/Tutorials/CMakeLists.txt ===
project(TutorialsExamples)

add_executable(FilteringPipeline FilteringPipeline.cxx)
target_link_libraries(FilteringPipeline ${OTB_LIBRARIES})

add_executable(HelloWorldOTB HelloWorldOTB.cxx)
target_link_libraries(HelloWorldOTB ${OTB_LIBRARIES})

add_executable(Multispectral Multispectral.cxx)
target_link_libraries(Multispectral ${OTB_LIBRARIES})

add_executable(OrthoFusion OrthoFusion.cxx)
target_link_libraries(OrthoFusion ${OTB_LIBRARIES})

add_executable(Pipeline Pipeline.cxx)
target_link_libraries(Pipeline ${OTB_LIBRARIES})

add_executable(ScalingPipeline ScalingPipeline.cxx)
target_link_libraries(ScalingPipeline ${OTB_LIBRARIES})

add_executable(SmarterFilteringPipeline SmarterFilteringPipeline.cxx)
target_link_libraries(SmarterFilteringPipeline ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Utilities/Doxygen/CMakeLists.txt ===
#
# Build the documentation
#
include (${CMAKE_ROOT}/Modules/Documentation.cmake)

mark_as_advanced(BUILD_DOCUMENTATION)

# -------------------------------------------------------------
#
# Generate Doxygen configuration file in all configuration file
#
if( ${DOXYGEN_DOT_FOUND} )
  set( OTB_HAVE_DOT "YES" )
else()
  set( OTB_HAVE_DOT "NO" )
endif()

set( DOX_MODULE_LIST ${OTB_MODULES_ENABLED} )

foreach(otb-module ${DOX_MODULE_LIST})
  if(${otb-module}_IS_TEST)
    list( APPEND DOXYGEN_TEST_DIRS "\"${${otb-module}_SOURCE_DIR}\" \\\n ")
  else()
    if( EXISTS ${${otb-module}_SOURCE_DIR}/include )
      list( APPEND DOXYGEN_INCLUDE_DIRS "\"${${otb-module}_SOURCE_DIR}/include\" \\ \n")
    endif()
  endif()
endforeach()

list( APPEND DOXYGEN_TEST_DIRS "\"${OTB_SOURCE_DIR}/Examples\" \\\n")

# By definition DOXYGEN_TEST_DIRS can not be empty. In the worst case if
# BUILD_TESTING is turned OFF, there is only ${OTB_SOURCE_DIR}/Examples;
# thus we don't need to do any replacement in the string.
if( BUILD_TESTING )
  # replace ";" in the string by space+backslash+newline
  string( REPLACE ";" " \\\\n" DOXYGEN_TEST_DIRS ${DOXYGEN_TEST_DIRS} )
endif()

list( LENGTH DOXYGEN_INCLUDE_DIRS _doxygen_include_dirs_size )

if( ${_doxygen_include_dirs_size} GREATER 0 )
  # replace ";" in the string by space+backslash+newline
  string( REPLACE ";" " \\\\n" DOXYGEN_INCLUDE_DIRS ${DOXYGEN_INCLUDE_DIRS} )
endif()

#
# Configure the script and the doxyfile, then add target
#

set( OTB_DOXYGEN_OUTPUT_DIR ${OTB_BINARY_DIR}/Documentation/Doxygen )
file(MAKE_DIRECTORY ${OTB_DOXYGEN_OUTPUT_DIR})

set( OTB_DOXYGEN_INPUT ${DOXYGEN_INCLUDE_DIRS} )

SET( OTB_DOXYGEN_DIAGRAMS YES )

option( OTB_DOXYGEN_HTML "Doxygen will generate HTML Output" ON )
option( OTB_DOXYGEN_DOCSET "Doxygen will generate additional index files for Xcode 3" OFF )
option( OTB_DOXYGEN_CHM "Doxygen will generate Microsoft HTML help" OFF )
option( OTB_DOXYGEN_QHP "Doxygen will generate Qt Compressed Help" OFF )
option( OTB_DOXYGEN_ECLIPSEHELP "Doxygen will generate Eclipse help plugin" OFF )
option( OTB_DOXYGEN_LATEX "Doxygen will generate LaTeX output" OFF )
option( OTB_DOXYGEN_RTF "Doxygen will generate RTF output optimized for Word 97" OFF )
option( OTB_DOXYGEN_XML "Doxygen will generate XML output" OFF )

mark_as_advanced( OTB_DOXYGEN_HTML
  OTB_DOXYGEN_DOCSET
  OTB_DOXYGEN_CHM
  OTB_DOXYGEN_QHP
  OTB_DOXYGEN_ECLIPSEHELP
  OTB_DOXYGEN_LATEX
  OTB_DOXYGEN_RTF
  OTB_DOXYGEN_XML
)

set( OTB_DOXYGEN_OUTPUT
  HTML
  DOCSET
  CHM
  QHP
  ECLIPSEHELP
  LATEX
  RTF
  XML
)

foreach( var ${OTB_DOXYGEN_OUTPUT} )
  if( OTB_DOXYGEN_${var} )
    set( OTB_DOXYGEN_GEN_${var} "YES" )
  else()
    set( OTB_DOXYGEN_GEN_${var} "NO" )
  endif()
endforeach()

set(OTB_DOXYGEN_ITK_TAGFILE "" CACHE FILEPATH "Tagfile containing ITK doxygen")
mark_as_advanced(OTB_DOXYGEN_ITK_TAGFILE)

set(OTB_DOXYGEN_ITK_DOXYGEN_URL "" CACHE STRING "URL to ITK doxygen")
mark_as_advanced(OTB_DOXYGEN_ITK_DOXYGEN_URL)

if(("${OTB_DOXYGEN_ITK_TAGFILE}" STREQUAL "") OR ("${OTB_DOXYGEN_ITK_DOXYGEN_URL}" STREQUAL ""))
  set(OTB_DOXYGEN_TAGFILE_FIELD "")
else()
  set(OTB_DOXYGEN_TAGFILE_FIELD "${OTB_DOXYGEN_ITK_TAGFILE}=${OTB_DOXYGEN_ITK_DOXYGEN_URL}")
endif()

find_package( Perl )

if( PERL_FOUND )
  set( OTB_DOXYGEN_INPUT_FILTER
    "${PERL_EXECUTABLE} ${OTB_BINARY_DIR}/Utilities/Doxygen/otbdoxygen.pl" )

  configure_file(${OTB_SOURCE_DIR}/Utilities/Doxygen/otbdoxygen.pl.in
               ${OTB_BINARY_DIR}/Utilities/Doxygen/otbdoxygen.pl)
else()
  set( OTB_DOXYGEN_INPUT_FILTER )
endif()

configure_file(${OTB_SOURCE_DIR}/Utilities/Doxygen/doxygen.config.in
               ${OTB_BINARY_DIR}/Utilities/Doxygen/doxygen.config)


#set( OTB_DOXYGEN_OUTPUT_DIR ${OTB_BINARY_DIR}/temp )

set( OTB_DOXYGEN_INPUT "\"INPUT_SINGLE_FILE\"" )

set( OTB_DOXYGEN_DIAGRAMS NO )


configure_file(${OTB_SOURCE_DIR}/Utilities/Doxygen/doxygen.config.in
               ${OTB_BINARY_DIR}/single-doxygen.config)

# -------------------------------------------------------------
if (BUILD_DOCUMENTATION)

  find_package( LATEX )

  if( NOT LATEX_COMPILER )
    message( "Warning: LaTeX not found. Formulas will not be generated in documentation." )
  endif()

  # Custom command to generate a examples page which include all OTB examples
  #add_custom_command( OUTPUT "${OTB_BINARY_DIR}/Documentation/Doxygen/Examples.dox"
  #  COMMAND ${CMAKE_COMMAND} -D "PROJECT_SOURCE_DIR:PATH=${OTB_SOURCE_DIR}"
  #  -D "OUTPUT_FILE:PATH=${OTB_BINARY_DIR}/Documentation/Doxygen/Examples.dox"
  #  -P "${OTB_SOURCE_DIR}/Utilities/Doxygen/GenerateExamplesDox.cmake"
  #  WORKING_DIRECTORY "${OTB_SOURCE_DIR}/Examples"
  #  DEPENDS "${OTB_SOURCE_DIR}/Examples" "${OTB_SOURCE_DIR}/Utilities/Doxygen/GenerateExamplesDox.cmake"
  #  )

  add_custom_target(Documentation-doxygen
    COMMAND ${DOXYGEN_EXECUTABLE} ${OTB_BINARY_DIR}/Utilities/Doxygen/doxygen.config
    #COMMAND ${CMAKE_COMMAND} -E copy
    #  ${OTB_SOURCE_DIR}/Utilities/Doxygen/favicon.ico
    #  ${OTB_BINARY_DIR}/Documentation/Doxygen/html
    DEPENDS         ${OTB_BINARY_DIR}/Utilities/Doxygen/otbdoxygen.pl
   # DEPENDS         ${OTB_BINARY_DIR}/Documentation/Doxygen/Examples.dox
    WORKING_DIRECTORY ${OTB_BINARY_DIR}/Utilities/Doxygen
    )
  
  add_custom_target(Documentation
    COMMAND ${CMAKE_COMMAND} -E tar cjf
      ${OTB_BINARY_DIR}/Documentation/Doxygen/OTB-Doxygen-${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR}.tar.bz2
      ${OTB_BINARY_DIR}/Documentation/Doxygen/html
    DEPENDS Documentation-doxygen
    WORKING_DIRECTORY ${OTB_BINARY_DIR}/Documentation/Doxygen
    )

  # Somehow the logo image is not copied into the html folder.
  # Here we ensure that the logo image ends up in the right directory
  # where html pages could find it.



  message( STATUS
           "To generate Doxygen's documentation, you need to build the Documentation target"
         )

endif (BUILD_DOCUMENTATION)

=== Examples/DataRepresentation/Path/CMakeLists.txt ===
project(PathExamples)

add_executable(PolyLineParametricPath1 PolyLineParametricPath1.cxx )
target_link_libraries(PolyLineParametricPath1 ${OTB_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/FeatureExtraction/test/CMakeLists.txt ===
set(BASELINE ${OTB_DATA_ROOT}/Baseline/Examples/FeatureExtraction)
set(INPUTDATA ${OTB_DATA_ROOT}/Examples)

# ------- CorrelationLineDetectorExampleTest----------

otb_add_test(NAME feTeCorrelationLineDetectorExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 2
    ${BASELINE}/amstLineCorrelations.png
    ${TEMP}/amstLineCorrelations.png
    ${BASELINE}/amstLineCorrelationDirections.png
    ${TEMP}/amstLineCorrelationDirections.png
  Execute $<TARGET_FILE:CorrelationLineDetectorExample>
    ${INPUTDATA}/amst.png
    ${TEMP}/amstLineCorrelations.png
    ${TEMP}/amstLineCorrelationDirections.png
    5 1
)

# ------- LocalHoughExampleTest----------

otb_add_test(NAME feTeLocalHoughExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 1
    ${BASELINE}/detected_local_hough.png
    ${TEMP}/detected_local_hough.png
  Execute $<TARGET_FILE:LocalHoughExample>
    ${INPUTDATA}/detected_lines.png
    ${TEMP}/detected_local_hough.png
    30 10 1 50
)

# ------- HarrisExampleTest----------

otb_add_test(NAME feTeHarrisExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 1
    ${BASELINE}/ROISpot5Harris.png
    ${TEMP}/ROISpot5Harris.png
  Execute $<TARGET_FILE:HarrisExample>
    ${INPUTDATA}/ROISpot5.png
    ${TEMP}/ROISpot5Harris.png
    1.5 2 0.1
)

# ------- TouziEdgeDetectorExampleTest----------

otb_add_test(NAME feTeTouziEdgeDetectorExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 2
    ${BASELINE}/amstTouziEdges.png
    ${TEMP}/amstTouziEdges.png
    ${BASELINE}/amstTouziDirections.png
    ${TEMP}/amstTouziDirections.png
  Execute $<TARGET_FILE:TouziEdgeDetectorExample>
    ${INPUTDATA}/amst.png
    ${TEMP}/amstTouziEdges.png
    ${TEMP}/amstTouziDirections.png
    3
)

# ------- ExtractSegmentsByStepsExampleTest----------

otb_add_test(NAME feTeExtractSegmentsByStepsExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 1
    ${BASELINE}/amstSegmentExtractionBySteps.png
    ${TEMP}/amstSegmentExtractionBySteps.png
  Execute $<TARGET_FILE:ExtractSegmentsByStepsExample>
    ${INPUTDATA}/amst_ers1.ima.extrait.419_187_70_66.hdr
    ${TEMP}/amstSegmentExtractionBySteps.png
    10 3 10 0.5 10 10 3 10 0.5
)

# ------- AssymmetricFusionOfLineDetectorExampleTest----------

otb_add_test(NAME feTeAssymmetricFusionOfLineDetectorExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 1
    ${BASELINE}/amstLineFusion.png
    ${TEMP}/amstLineFusion.png
  Execute $<TARGET_FILE:AssymmetricFusionOfLineDetectorExample>
    ${INPUTDATA}/amst.png
    ${TEMP}/amstLineFusion.png
    5 1
)

# ------- ExtractSegmentsExampleTest----------

otb_add_test(NAME feTeExtractSegmentsExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 1
    ${BASELINE}/amstSegmentExtraction.png
    ${TEMP}/amstSegmentExtraction.png
  Execute $<TARGET_FILE:ExtractSegmentsExample>
    ${INPUTDATA}/amst_ers1.ima.extrait.419_187_70_66.hdr
    ${TEMP}/amstSegmentExtraction.png
    10 3 10 0.5 10 10 3 10 0.5
)

# ------- RatioLineDetectorExampleTest----------

otb_add_test(NAME feTeRatioLineDetectorExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 2
    ${BASELINE}/amstLineRatios.png
    ${TEMP}/amstLineRatios.png
    ${BASELINE}/amstLineRatioDirections.png
    ${TEMP}/amstLineRatioDirections.png
  Execute $<TARGET_FILE:RatioLineDetectorExample>
    ${INPUTDATA}/amst.png
    ${TEMP}/amstLineRatios.png
    ${TEMP}/amstLineRatioDirections.png
    5 1
)

# ------- AlignmentsExampleTest----------
if(OTBMathParser_LOADED)
otb_add_test(NAME feTeAlignmentsExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 1
    ${BASELINE}/QB_SuburbAlign.png
    ${TEMP}/QB_SuburbAlign.png
  Execute $<TARGET_FILE:AlignmentsExample>
    ${INPUTDATA}/QB_Suburb.png
    ${TEMP}/QB_SuburbAlign.png
    5
)

# ------- RoadExtractionExamplesTest----------


otb_add_test(NAME feTeExtractRoadByStepsExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 2
    ${BASELINE}/qb_ExtractRoad_pretty.png
    ${TEMP}/qb_ExtractRoad_pretty.png
    ${BASELINE}/ExtractRoadByStepsExampleOutput.png
    ${TEMP}/ExtractRoadByStepsExampleOutput.png
  Execute $<TARGET_FILE:ExtractRoadByStepsExample>
    ${INPUTDATA}/qb_RoadExtract.tif
    ${TEMP}/ExtractRoadByStepsExampleOutput.png
    ${TEMP}/qb_ExtractRoad_pretty.png
    337 557 432 859 0.00005 1.0
)


otb_add_test(NAME feTeExtractRoadExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-image ${NOTOL}
    ${BASELINE}/ExtractRoadExampleOutput.png
    ${TEMP}/ExtractRoadExampleOutput.png
  Execute $<TARGET_FILE:ExtractRoadExample>
    ${INPUTDATA}/qb_RoadExtract.tif
    ${TEMP}/ExtractRoadExampleOutput.png
    337 557 432 859 1.0 0.00005 1.0 0.39269 1.0 10.0 25.
)

endif()

# ------- SeamCarvingExamplesTest----------

otb_add_test(NAME feTeSeamCarvingExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-image ${NOTOL}
    ${BASELINE}/SeamCarvingExampleOutput.png
    ${TEMP}/SeamCarvingExampleOutput.png
  Execute $<TARGET_FILE:SeamCarvingExample>
    ${INPUTDATA}/QB_Suburb.png
    ${TEMP}/SeamCarvingExampleOutput.png
    50
)

otb_add_test(NAME feTeSeamCarvingOtherExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-image ${NOTOL}
    ${BASELINE}/SeamCarvingOtherExampleOutput.png
    ${TEMP}/SeamCarvingOtherExampleOutput.png
  Execute $<TARGET_FILE:SeamCarvingOtherExample>
    ${INPUTDATA}/QB_Suburb.png
    ${TEMP}/SeamCarvingOtherExampleOutput.png
    50
)

#otb_add_test(NAME feTeImageToSIFTKeyPointSetFilterTest COMMAND ${OTB_TEST_DRIVER}
#        --compare-image ${NOTOL}
#        ${BASELINE}/ImageToSIFTKeyPointSetFilterOutput.png
#        ${TEMP}/ImageToSIFTKeyPointSetFilterOutput.png
#        Execute $<TARGET_FILE:ImageToSIFTKeyPointSetFilter>
#        ${INPUTDATA}/Scene.png
#        ${TEMP}/ImageToSIFTKeyPointSetFilterOutput.png
#        6 3 0.08 10
#)


# ------- CloudDetectionExampleTest----------

otb_add_test(NAME feTeCloudDetectionExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-image ${NOTOL}
    ${BASELINE}/CloudDetectionOutput.png
    ${TEMP}/PrettyCloudDetectionOutput.png
  Execute $<TARGET_FILE:CloudDetectionExample>
    ${INPUTDATA}/CloudsOnReunion.tif
    ${TEMP}/CloudDetectionOutput.tif
    ${TEMP}/PrettyCloudDetectionInput.png
    ${TEMP}/PrettyCloudDetectionOutput.png
    553 467 734 581 0.4 0.6 1.0
)

if (Module_OTBVectorDataRendering AND OTB_USE_MAPNIK)

  # ------- Line Segment Detector test----------
  otb_add_test(NAME feTeLineSegmentDetectorExampleTest  COMMAND ${OTB_TEST_DRIVER}
    --compare-image ${NOTOL}
      ${BASELINE}/feTeLineSegmentDetectorExampleOutput.png
      ${TEMP}/feTeLineSegmentDetectorExampleOutput.png
    Execute $<TARGET_FILE:LineSegmentDetectorExample>
      ${INPUTDATA}/Scene.png
      ${TEMP}/feTeLineSegmentDetectorExampleOutput.png
  )

  # ------- Right Angle Detection test----------

  otb_add_test(NAME feTeRightAngleDetectionExample  COMMAND ${OTB_TEST_DRIVER}
    --compare-image ${NOTOL}
      ${BASELINE}/feTeRightAngleDetectionExampleOutput.png
      ${TEMP}/feTeRightAngleDetectionExampleOutput.png
    Execute $<TARGET_FILE:RightAngleDetectionExample>
      ${INPUTDATA}/Scene.png
      ${TEMP}/feTeRightAngleDetectionExampleOutput.png
      ${TEMP}/PrettyRightAngleInput.png
      ${TEMP}/PrettyRightAngleOutput.png
      0.1
      10.
  )
endif()

=== debian/changelog ===
otb (5.6.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop spelling-errors.patch, applied upstream.
  * Update copyright file, changes:
    - Update list of LGPL-2 ossim plugin files
    - Add license & copyright for SPTW
  * Add python-numpy to build dependencies.
  * Override dh_python2 to call dh_numpy too.
  * Add patch to only use OTB_GIT_STATUS_MESSAGE in message function if set.
  * Update symbols for amd64 & i386.
  * Add library package for libOTBStatistics.
  * Add patch to fix spelling errors.
  * Add manpages for new executables.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 29 Jul 2016 14:26:00 +0200

otb (5.4.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Drop unused overrides for spelling-error-in-binary false positives.
  * Update spelling-errors.patch to fix 'symmetric' typo.
  * Rebuild with ITK 4.10.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 25 Jul 2016 11:32:41 +0200

=== debian/control ===
Source: otb
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Paolo Cavallini <cavallini@faunalia.it>,
           Rashad Kanavath <rashad.kanavath@c-s.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1~),
               dh-exec,
               pkg-kde-tools,
               cmake (>= 2.8.3),
               libboost-graph-dev,
               libcurl4-gnutls-dev,
               libexpat1-dev,
               libfftw3-dev,
               libgdal-dev (>= 1.10.0),
               libgeotiff-dev,
               libgl1-mesa-dev | libgl-dev,
               libglew-dev,
               libglfw3-dev,
               libinsighttoolkit4-dev,
               libkml-dev,
               libmuparser-dev,
               libpng-dev,
               libproj-dev,
               libtool,
               libopencv-dev,
               libopenthreads-dev,
               libossim-dev,
               libqt4-dev,
               libtinyxml-dev,
               python-dev,
               python-numpy,
               swig
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/otb.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/otb.git
Homepage: http://www.orfeo-toolbox.org/

Package: libotb-dev
Architecture: any
Section: libdevel
Depends: cmake (>= 2.8.3),
         libboost-graph-dev,
         libgdal-dev (>= 1.10.0),
         libgeotiff-dev,
         libgl1-mesa-dev | libgl-dev,
         libglew-dev,
         libglfw3-dev,
         libinsighttoolkit4-dev,
         libkml-dev,
         libmuparser-dev,
         libopencv-dev,
         libopenthreads-dev,
         libossim-dev,
         libotbapplicationengine-5.6-1 (= ${binary:Version}),
         libotbcarto-5.6-1 (= ${binary:Version}),
         libotbcommandline-5.6-1 (= ${binary:Version}),
         libotbcommandlineparser-5.6-1 (= ${binary:Version}),
         libotbcommon-5.6-1 (= ${binary:Version}),
         libotbcurladapters-5.6-1 (= ${binary:Version}),
         libotbedge-5.6-1 (= ${binary:Version}),
         libotbextendedfilename-5.6-1 (= ${binary:Version}),
         libotbfuzzy-5.6-1 (= ${binary:Version}),
         libotbgdaladapters-5.6-1 (= ${binary:Version}),
         libotbice-5.6-1 (= ${binary:Version}),
         libotbimagebase-5.6-1 (= ${binary:Version}),
         libotbimageio-5.6-1 (= ${binary:Version}),
         libotbimagemanipulation-5.6-1 (= ${binary:Version}),
         libotbiobsq-5.6-1 (= ${binary:Version}),
         libotbiogdal-5.6-1 (= ${binary:Version}),
         libotbiokml-5.6-1 (= ${binary:Version}),
         libotbiolum-5.6-1 (= ${binary:Version}),
         libotbiomstar-5.6-1 (= ${binary:Version}),
         libotbiomw-5.6-1 (= ${binary:Version}),
         libotbioonera-5.6-1 (= ${binary:Version}),
         libotbiorad-5.6-1 (= ${binary:Version}),
         libotbiotilemap-5.6-1 (= ${binary:Version}),
         libotbmathparser-5.6-1 (= ${binary:Version}),
         libotbmetadata-5.6-1 (= ${binary:Version}),
         libotbopenthreadsadapters-5.6-1 (= ${binary:Version}),
         libotbossimadapters-5.6-1 (= ${binary:Version}),
         libotbossimplugins-5.6-1 (= ${binary:Version}),
         libotbpolarimetry-5.6-1 (= ${binary:Version}),
         libotbprojection-5.6-1 (= ${binary:Version}),
         libotbqtwidget-5.6-1 (= ${binary:Version}),
         libotbrcc8-5.6-1 (= ${binary:Version}),
         libotbsampling-5.6-1 (= ${binary:Version}),
         libotbsiftfast-5.6-1 (= ${binary:Version}),
         libotbstatistics-5.6-1 (= ${binary:Version}),
         libotbstreaming-5.6-1 (= ${binary:Version}),
         libotbsupervised-5.6-1 (= ${binary:Version}),
         libotbtestkernel-5.6-1 (= ${binary:Version}),
         libotbtransform-5.6-1 (= ${binary:Version}),
         libotbvectordatabase-5.6-1 (= ${binary:Version}),
         libotbvectordataio-5.6-1 (= ${binary:Version}),
         libotbwavelet-5.6-1 (= ${binary:Version}),
         otb-testdriver (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libotb3-dev,
           libotb4-dev
Description: Free library of image processing algorithms - development
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the development files needed to build your own OTB
 applications and modules.

Package: otb-testdriver
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ORFEO Toolbox library - OTBTestDriver
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBTestDriver application.

Package: libotbice-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIce
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIce shared library.

Package: libotbiolum-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOLUM
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOLUM shared library.

Package: libotbiomstar-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOMSTAR
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOMSTAR shared library.

Package: libotbiomw-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOMW
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOMW shared library.

Package: libotbioonera-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOONERA
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOONERA shared library.

Package: libotbiorad-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIORAD
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIORAD shared library.

Package: libotbiotilemap-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOTileMap
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOTileMap shared library.

Package: libotbiogdal-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOGDAL
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOGDAL shared library.

Package: libotbiobsq-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOBSQ
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOBSQ shared library.

Package: libotbiokml-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOKML
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOKML shared library.

Package: libotbcurladapters-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBCurlAdapters
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBCurlAdapters shared library.

Package: libotbopenthreadsadapters-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBOpenThreadsAdapters
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBOpenThreadsAdapters shared library.

Package: libotbossimadapters-5.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBOssimAdapters
 ORFEO Toolbox (OTB) is distributed as an open source library of image

=== debian/rules ===
#!/usr/bin/make -f
#
# Copyright (C) 2010-2014 CNES - Centre National d'Etudes Spatiales
# Author: Sebastien DINOT <sebastien.dinot@c-s.fr>
#
# The OTB is distributed under the CeCILL license version 2. See files
# Licence_CeCILL_V2-en.txt (english version) or Licence_CeCILL_V2-fr.txt
# (french version) in 'Copyright' directory for details. This licenses are
# also available online:
# http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
# http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = "-Wl,--as-needed"

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifndef PKGVERSION
    PKGVERSION=1
endif

TEMPLATES=$(wildcard debian/*lintian-overrides.in)

OTB_VERSION_MAJOR  = $(shell sed -ne 's/set(OTB_VERSION_MAJOR "\([0-9]*\)")/\1/p' CMakeLists.txt)
OTB_VERSION_MINOR  = $(shell sed -ne 's/set(OTB_VERSION_MINOR "\([0-9]*\)")/\1/p' CMakeLists.txt)
OTB_VERSION_PATCH  = $(shell sed -ne 's/set(OTB_VERSION_PATCH "\([0-9]*\)")/\1/p' CMakeLists.txt)
OTB_VERSION_SONAME = $(OTB_VERSION_MAJOR).$(OTB_VERSION_MINOR)
OTB_VERSION_FULL   = $(OTB_VERSION_MAJOR).$(OTB_VERSION_MINOR).$(OTB_VERSION_PATCH)

UPSTREAM_VERSION = $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')

CMAKE_FLAGS = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_BUILD_TYPE:STRING=Release \
	-DOTB_INSTALL_LIBRARY_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	-DOTB_INSTALL_ARCHIVE_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DOTB_USE_CURL:BOOL=ON \
	-DOTB_USE_GLEW:BOOL=ON \
	-DOTB_USE_GLFW:BOOL=ON \
	-DOTB_USE_LIBKML:BOOL=ON \
	-DOTB_USE_MUPARSER:BOOL=ON \
	-DOTB_USE_QT4:BOOL=ON \
	-DOTB_USE_OPENCV:BOOL=ON \
	-DOTB_USE_OPENGL:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DOTB_WRAP_PYTHON:BOOL=ON \
	-DBUILD_EXAMPLES:BOOL=OFF \
	-DBUILD_TESTING:BOOL=OFF \
	-DOTB_USE_MAPNIK:BOOL=OFF \
	-DOTB_USE_6S:BOOL=OFF \
	-DOTB_USE_MUPARSERX:BOOL=OFF \
	-DOTB_USE_OPENJPEG:BOOL=OFF \
	-DOTB_USE_LIBSVM:BOOL=OFF


DEBPKGNAME     := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')
pkgcli:=$(DEBPKGNAME)-bin
pkggui:=$(DEBPKGNAME)-bin-qt
pkglib:=lib$(DEBPKGNAME)
pkgdev:=$(pkglib)-dev

templates:

	for TEMPLATE in $(TEMPLATES) ; do \
		sed -e 's/@SOVERSION@/$(OTB_VERSION_SONAME)-1/g' $$TEMPLATE > `echo $$TEMPLATE | sed 's/.lintian-overrides.in$$/-$(OTB_VERSION_SONAME)-1.lintian-overrides/'` ; \
	done
	sed -e 's/@SOVERSION@/$(OTB_VERSION_SONAME)-1/g' debian/control.in > debian/control
	sed -e 's/@SOVERSION@/$(OTB_VERSION_SONAME)/g' debian/libotb-dev.install.in > debian/libotb-dev.install

# rather use all libs since the installed libs are spread over several packages
OTB_LIB_DIRS = $(CURDIR)/debian/tmp/usr/lib

%:
	dh $@ --with pkgkde_symbolshelper --parallel

override_dh_auto_configure: templates
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(UPSTREAM_VERSION)

override_dh_shlibdeps:
	dh_shlibdeps -l$(OTB_LIB_DIRS)

override_dh_install:
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/OTB-$(OTB_VERSION_SONAME)/LICENSE
	rm -f $(CURDIR)/debian/tmp/usr/lib/otb/python/otbApplication.pyc
	dh_install --list-missing
	rm -f $(CURDIR)/debian/$(pkglib)/usr/lib/$(DEB_HOST_MULTIARCH)/libOTBWrapper*
	rm -f $(CURDIR)/debian/$(pkgdev)/usr/lib/$(DEB_HOST_MULTIARCH)/libOTBWrapper*

override_dh_installchangelogs:
	dh_installchangelogs RELEASE_NOTES.txt

override_dh_python2:
	dh_python2
	dh_numpy

.PHONY: templates
